parameters user_num, numCon;

create procedure SetGDBID ( in @userNum integer )
begin
  declare @stmt long varchar;
  set @stmt = 'set option public.Global_database_id = 1' || {user_num};
  execute immediate @stmt;
end;

call SetGDBID( {user_num} );

set option public.delete_old_logs = 'ON';

create table Admin (
  admin_id bigint default global autoincrement(1000000) primary key,
  data     varchar(30),
  cons     integer
);

create procedure rep_data(in iter integer default 1,in do_commit integer default 0)
begin
  declare i integer;
  set i=0;
  while i < iter loop
    insert into admin(data,cons) values(cast(rand(*)*20+1 as char(10)),cast(rand(*)*{numCon}+1 as integer));
    set i=i+1;
    if do_commit = 1 then
      commit;
    end if;
  end loop;
  commit;
end;

create synchronization user "rem{user_num}";

create procedure MakePubs( in @numCon integer )
begin
  declare i integer;
  declare @stmt long varchar;
  
  set i = 1;
  while ( i <= @numCon ) loop
    set @stmt = 'create publication con' || i || '( table Admin(admin_id,data,cons) where cons = ' || i || ')';
    message @stmt;
    execute immediate @stmt;
    set @stmt = 'create synchronization subscription to con' || i || ' for "rem{user_num}" type ''tcpip'' address ''host=localhost;port=900' || i || ''' option sv=''v1''';
    message @stmt;
    execute immediate @stmt;
    set i = i + 1;
  end loop;
end;

call MakePubs( {numCon} );

call rep_data( {numCon}0 );
